/* auconn, wavconn  (pathlist, extlist) ˴ؤ routine
 * shige
 * 09/30 2000
 * conf.c
 *
 * $Id: conf.c,v 1.15 2009-07-13 11:15:48+09 shige Exp $
 */
#ifndef __CONF_C__
#define __CONF_C__

#include "conf.h"

/* ########## data file path or ext list subroutine ########## */
int initpathextlist(char *env[])
{
    if(addenv2pathlist(env)<0 || addenv2extlist(env)<0 
       || getenv2nullfname(env)<0
       || addfile2list(DEFAULTConffname)<0
       || addstr2pathlist(DEFAULTPathlist)<0
       || addstr2extlist(DEFAULTExtlist)<0)
      return Exit_envdefault;
    if(NULLFname==undefs) NULLFname=NULL;
    return No_err;
}

/* ʸ path list 
 */
/* mystrtok  */
int addstr2pathlist(char *str)
{
    int j=0,k;
    char *s;

    if(str==NULL || (k=strlen(str))<=0) return 0;
    if(k>=Maxbuff) return Err_pathstr;
    s=newfname(mystrtok(str,Pathlistdelimiter));
    do{
	/* ˤ뤫 check */
	for(k=1;k<=pathlistnum;k++)
	  if(strcmp(pathlist[k-1],s)==0) break;
	if(k>pathlistnum){
	    if(++pathlistnum>Maxpathlists) return Err_manylists;
	    j++;
	    if((pathlist[pathlistnum-1]=(char *)malloc(strlen(s)+1))==NULL)
	      return Err_malloc;
	    strcpy(pathlist[pathlistnum-1],s);
	}
    }while((s=newfname(mystrtok(NULL,Pathlistdelimiter)))!=NULL);
    return j;
}

/* ʸ ext list 
 */
int addstr2extlist(char *str)
{
    int j=0,k;
    char *s;

    if(str==NULL || (k=strlen(str))<=0) return 0;
    if(k>=Maxbuff) return Err_extstr;
    s=mystrtok(str,Extlistdelimiter);
    do{
	/* ˤ뤫 check */
	for(k=1;k<=extlistnum;k++)
	  if(strcmp(extlist[k-1],s)==0) break;
	if(k>extlistnum){
	    if(++extlistnum>Maxextlists) return Err_manylists;
	    j++;
	    strcpy(extlist[extlistnum-1],s);
	}
    }while((s=mystrtok(NULL,Extlistdelimiter))!=NULL);
    return j;
}

/* Ķѿɤʸ path list 
 */
int addenv2pathlist(char *env[])
{
    int len,j;

    len=strlen(DEFAULTPathEnvname);
    for(j=0;env[j]!=NULL;j++)
      if(strncmp(DEFAULTPathEnvname,env[j],len)==0)
	return addstr2pathlist(env[j]+len+1);
    return No_err;
}

/* Ķѿɤʸ ext list 
 */
int addenv2extlist(char *env[])
{
    int len,j;

    len=strlen(DEFAULTExtEnvname);
    for(j=0;env[j]!=NULL;j++)
      if(strncmp(DEFAULTExtEnvname,env[j],len)==0)
	return addstr2extlist(env[j]+len+1);
    return No_err;
}

/* Ķѿɤʸ ext list 
 * 1: already defined, 2: set, 0: not set
 */
int getenv2nullfname(char *env[])
{
    int len,j;
    
    if(NULLFname!=undefs) return 1; /* already defined */
    len=strlen(DEFAULTNULLFEnvname);
    for(j=0;env[j]!=NULL;j++)
      if(strncmp(DEFAULTNULLFEnvname,env[j],len)==0){
	  if(strlen(env[j])==len+1) NULLFname=NULL;
	  else NULLFname=env[j]+len+1;
	  return 2;
      }
    return 0;
}


/* configuration file ɤʸ path ext list 
 */
int addfile2list(char *fname)
{
    FILE *infile;
    char buff[Maxbuff],*s;
    int ret,total=0;

#ifdef DEBUG2
    fprintf(stderr,"[debug2] fname=%s\n",fname);
#endif /* DEBUG2 */

    if((infile=fopen(newfname(fname),"r"))==NULL){
	/* if(verbose) fprintf("File [%s] is not found.\n",fname); */
	return No_err;
    }
    while(fgets(buff,Maxbuff,infile)!=NULL){
	if(strlen(buff)==Maxbuff-1 && buff[Maxbuff-2]!='\n')
	  return Err_longconf;
	if((s=strtok(buff,Confdelimiter))!=NULL && *s!=Confcomment){
	    if(!strcmp(s,"path")){ /* "path" option */
		if((s=strtok(NULL,Confdelimiter))==NULL) 
		  return Err_conf;
		if((ret=addstr2pathlist(s))<=0) return ret;
		else total+=ret;
	    }
	    else if(!strcmp(s,"ext")){ /* "ext" option */
		if((s=strtok(NULL,Confdelimiter))==NULL) 
		  return Err_conf;
		if((ret=addstr2extlist(s))<=0) return ret;
		else total+=ret;
	    }
	    else if(!strcmp(s,"nullfile")){ /* "nullfile" option */
		if(NULLFname==undefs){
		    if((s=strtok(NULL,Confdelimiter))==NULL) 
		      return Err_conf;
		    if(*s=='-' || strlen(s)==0) NULLFname=NULL;
		    else if((NULLFname=(char *)malloc(strlen(s)+1))==NULL)
		      return Err_malloc;
		    else strcpy(NULLFname,s);
		}
	    }
	}
    }
    fclose(infile);
    return total;
}

/* HOME Ķѿ set */
int inithome(char *env[])
{
    int j;

    for(j=0;env[j]!=NULL;j++)
      if(strncmp("HOME=",env[j],4+1)==0){
	  HOME=env[j]+4+1;
	  return 1;
      }
    return 0;
}

/* '~'  $HOME Ÿ
 */
char *newfname(char *fname)
{
    static char tmp[Maxpathlen];

    if(fname==NULL) return NULL;
    if(*fname != Homechar || HOME==NULL) return fname;
    if(strlen(fname)-1+strlen(HOME)+1>Maxpathlen) /* Ĺ */
      return fname;
    strcpy(tmp,HOME);
    return strcat(tmp,fname+1);
}

/* fopenpathlist() β
 * extlist[] Ĥƥե򸡺
 */
FILE *searchextlist(char *fname)
{
    int k,extlen,fnamelen;
    char buff[Maxpathlen];
    FILE *tmpf;
    
    if((fnamelen=strlen(fname))<=0 || fnamelen>Maxpathlen) 
      return (FILE *)NULL;
    strcpy(buff,fname);
    for(k=1;k<=extlistnum;k++){
	extlen=strlen(extlist[k-1]);
	if(fnamelen+extlen>Maxpathlen) continue;
	buff[fnamelen]='\0';
	strcat(buff,extlist[k-1]);
#ifdef DEBUG4
	fprintf(stderr,"[debug4] buff=[%s]\n",buff);
#endif
	if((tmpf=fopen(buff,"r"))!=NULL){
	    if(listonly) printf("%s\n",buff);
	    return tmpf;
	}
    }
    return (FILE *)NULL;
}

/*  (cf. ¼֥르ꥺŵ)
 * h[0]~h[num-1] 
 */
void randomperm(int h[],int num)
{
    static int init=0;
    int j,tmp,x;

    if(num<=0) return;
    if(init==0){ srand((unsigned)time(NULL)); init=1; }
    for(j=1;j<=num;j++) h[j-1]=j-1;
    for(j=num-1;j>0;j--){
	x=(int)((j+1)*(double)rand()/(RAND_MAX+1.0));
	tmp=h[x]; h[x]=h[j]; h[j]=tmp;
    }
}

void initorder(void)
{
    int j;

    for(j=1;j<=pathlistnum;j++) order[j-1]=j-1;
}

/* order[] 򹹿
 * mode=1: ȥ졼 ()
 * mode=2: random
 * mode=3: 1 ܤ param ܤ swap 
 * mode=4: param ܤΤ (mode=3 ƱǤ褤)
 */
int updateorder(int mode, int param)
{
    int j;

    if(mode<=0 || mode>4) return -1;
    if(mode==1) for(j=1;j<=pathlistnum;j++) order[j-1]=j-1;
    else if(mode==2) randomperm(order,pathlistnum);
    else if(mode==3){ /* mode==3; param Ƭ */
	if(param<=0 || param>pathlistnum) return -2;
	order[0]=param-1;
	for(j=1;j<param;j++) order[j]=j-1;
	for(j=param+1;j<=pathlistnum;j++) order[j-1]=j-1;
    }
    else{ /* mode==4 */
	if(param<=0 || param>pathlistnum) return -3;
	for(j=1;j<=pathlistnum;j++) order[j-1]=j-1;
	if(param>1){ order[0]=param-1; order[param-1]=0; }
    }
    return 0;
}

/* mode=-1: ꤷ pathlist ľܳ
 * mode=0: ľ
 * mode=1: ȥ졼 ()
 * mode=2: random
 * mode=3: param ܤ 1 ܤ˻äƤ (param ͥ)
 * mode=4: param ܤΤ (param  1  swap Ф)
 * *pathnum: ºݤ˸Ĥäֹ¸
 */
FILE *fopenpathlist(char *fname,int mode,int param,int *pathnum)
{
    int j,pathlen,fnamelen,num;
    char buff[Maxpathlen];
    static int init=0,checknums=0;
    FILE *tmpf;

#ifdef DEBUG4
    fprintf(stderr,"[debug4] fopenpathlist(%s,%d,*)\n",fname,mode);
#endif
    if((fnamelen=strlen(fname))<=0 || fnamelen>Maxpathlen) 
      return (FILE *)NULL;
#ifdef WITHPATHOPEN
    /* fname  path ʬĤƤޤ open Ƥߤ */
#ifdef DEBUG4
    fprintf(stderr,"[debug4] iswithpath()=%d\n",iswithpath(fname));
#endif
    if(iswithpath(fname) ||(mode==-1 && pathnum!=NULL && *pathnum==-1))
      if((tmpf=searchextlist(fname))!=NULL){ 
	  if(pathnum!=NULL) *pathnum=-1; 
	  return tmpf; 
      }
#endif /* WITHPATHOPEN */
    if(init==0){ 
	if(mode==-1) return (FILE *)NULL;
	initorder(); init=1; 
	checknums=pathlistnum;
    }
    if(mode>0){ /* ι */
	if(updateorder(mode,param)<0) return (FILE *)NULL; 
	if(mode==4) checknums=1;
	else checknums=pathlistnum;
    }
    else if(mode==-1){ /* ľ */
	if(pathnum==NULL) return (FILE *)NULL;
	if(strlen(pathlist[*pathnum])>0){
	    strcpy(buff,pathlist[*pathnum]);
	    mystrcat(buff,Pathdelimiter);
	}
	else buff[0]='\0';
	strcat(buff,fname);
	return searchextlist(buff);
    }
#ifdef DEBUG4
    fprintf(stderr,"[debug4] checknums=%d\n",checknums);
#endif
    for(j=1;j<=checknums;j++){
	num=order[j-1];
	if(pathnum!=NULL) *pathnum=num;
	pathlen=strlen(pathlist[num]);
#ifdef DEBUG4
	fprintf(stderr,"[debug4] [%d] pathlist[%d]=%s\n",j,num,pathlist[num]);
#endif
	if(pathlen+1+fnamelen>Maxpathlen) continue;
	if(pathlen>0){
	    strcpy(buff,pathlist[num]);
	    mystrcat(buff,Pathdelimiter);
	}
	else buff[0]='\0';
	strcat(buff,fname);
	if((tmpf=searchextlist(buff))!=NULL) return tmpf;
    }
    if(verbose) fprintf(stderr,"File [%s] is not found.\n",fname);
    return (FILE *)NULL;
}

/* ########## string ########## */
/* 1) strtok()  constant ʸؤϻȤʤ
 * 2) ":a::b"  "a", "b" ֤ʤ
 */
char *mystrtok(char *str,char c)
{
    static char tmp[Maxbuff];
    static char *s0,*s1,*s2;
    
    /* if(strlen(str)>=Maxbuff) return NULL; 
     * Ƚ̤ϳǤ뤳Ȥˤ
     */
    if(str!=NULL){
	strcpy(tmp,str);
	s0=tmp;
	s2=tmp+strlen(tmp);
    } 
    else{
	if(s1>=s2) return NULL;
	s0=s1+1;
    }
    s1=s0;
    while(*s1!=c)
      if(++s1>=s2) break;
    if(s1>=s2)
      return s0;
    *s1='\0';
    return s0;
}

char *mystrcat(char *str,char c)
{
    int len=strlen(str);

    *(str+len)=c;
    *(str+len+1)='\0';
    return str;
}

int iswithpath(char *filename)
{
    if(strchr(filename,Pathdelimiter)!=NULL) return 1;
    else return 0;
}

/* ##### DEBUG ##### */
#ifdef DEBUG4
void putallpathlist(void)
{
    int j;

    for(j=1;j<=pathlistnum;j++)
      fprintf(stderr,"[debug4] pathlist[%d]=[%s]\n",j-1,pathlist[j-1]);
}

void putallextlist(void)
{
    int j;

    for(j=1;j<=extlistnum;j++)
      fprintf(stderr,"[debug4] extlist[%d]=[%s]\n",j-1,extlist[j-1]);
}
#endif

#endif /* __CONF_C__ */
