#!/bin/sh
# the next line restarts using wish \
exec wish "$0" "$@"
##
## ץ󥭥ѥ¸ Tcl/Tk ץ
## shige
## 06/10 2004 (for test5.tcl)
## 07/18 2004 (for test6.tcl)
## 01/05 2005
## mksnd1.tcl
## 
## $Id: mksnd1.tcl,v 1.2 2005-01-05 21:32:45+09 shige Exp $
##

##
## Ķ
##
set gnuplot "gnuplot+"
# 1: gnuplot+, 0: gnuplot without plus
set gpp 1
set mksndbin "mksnd1"
set dataf "tmp.1"
set tmpf "tmp.dat"
# 1: Solaris /dev/audio, 2: FreeBSD /dev/audio, 3: use $auplay
set playmode 3
# 1: AU, 3: 8bit WAV, 5: 16bit WAV, 7: 16bit AIFF
set sndraw 1
# 2: AU, 4: 8bit WAV, 6: 16bit WAV, 8: 16bit AIFF
set sndform 6
set tmpsnd "tmp.au"
set auplay "auplay"

##
## subroutines
##

## İĤȢ
proc drawbox { c x y color tag } {
    global bw bh
    $c create rectangle [ expr $x-$bw/2 ] [ expr $y-$bh/2 ] \
	    [ expr $x+$bw/2 ] [ expr $y+$bh/2 ] -fill $color -tags $tag
#    puts $tag
}

proc box1color { c n color } {
    $c itemconfigure box1-$n -fill $color
}

proc box2color { c n color } {
    $c itemconfigure box2-$n -fill $color
}

## ȷ () οޤι
proc box1setup { c n x y } {
    global bx1 by1 N1 Y1 Y2 lw
#    puts "$by($n) $y"
    if { $y != $by1($n) } then {
	if { $y < $Y1 } then { set y $Y1 } elseif { $y > $Y2 } then { set y $Y2 }
	$c move box1-$n 0 [ expr $y - $by1($n) ]
	set by1($n) $y
    }
    if { $n > 1 } then {
	$c delete tags line1-[expr $n-1]
	$c create line $bx1([expr $n-1]) $by1([expr $n-1]) $bx1($n) $by1($n) \
		-tags line1-[expr $n-1] -width $lw
    }
    if { $n < $N1 } then {
	$c delete tags line1-$n
	$c create line $bx1([expr $n+1]) $by1([expr $n+1]) $bx1($n) $by1($n) \
		-tags line1-$n -width $lw
    }
}

##  () οޤι
proc box2setup { c n x y } {
    global bx2 by2 N2 Y1 Y2 lw
#    puts "$by($n) $y"
    if { $y != $by2($n) } then {
	if { $y < $Y1 } then { set y $Y1 } elseif { $y > $Y2 } then { set y $Y2 }
	$c move box2-$n 0 [ expr $y - $by2($n) ]
	set by2($n) $y
    }
    if { $n > 1 } then {
	$c delete tags line2-[expr $n-1]
	$c create line $bx2([expr $n-1]) $by2([expr $n-1]) $bx2($n) $by2($n) \
		-tags line2-[expr $n-1] -width $lw
    }
    if { $n < $N2 } then {
	$c delete tags line2-$n
	$c create line $bx2([expr $n+1]) $by2([expr $n+1]) $bx2($n) $by2($n) \
		-tags line2-$n -width $lw
    }
}

# ƥȽ
proc testputall { } {
    global bx1 by1 N1 h1
    global bx2 by2 N2 h2
    global sec freq

    set s [ transY $by1(1) 1 ]
    for { set i 2 } { $i <= $N1 } { incr i } {
	set y [ transY $by1($i) 1 ]
	set s "$s:$y"
    }
    puts $s

    set s [ transY $by2(1) 2 ]
    for { set i 2 } { $i <= $N2 } { incr i } {
	set y [ transY $by2($i) 2 ]
	set s "$s:$y"
    }
    puts $s
    puts "$sec:$freq"
}

proc putall { mode } {
    global bx1 by1 N1 h1
    global bx2 by2 N2 h2
    global sec freq
    global mksndbin dataf
    global tmpf tmpsnd
    global playmode sndraw sndform auplay
    set xdist1 10
    set xdist2 10

    set s1 [ transY $by1(1) 1 ]
    set s10 "$s1"
    #set s10 "$by1(1)"
    for { set i 2 } { $i <= $N1 } { incr i } {
	set y [ transY $by1($i) 1 ]
	set s1 "$s1:$xdist1:$y"
	set s10 "$s10 $y"
	#set s10 "$s10 $by1($i)"
    }
    set s1 "$s1:$xdist1"

    set s2 [ transY $by2(1) 2 ]
    set s20 "$s2"
    #set s20 "$by2(1)"
    for { set i 2 } { $i <= $N2 } { incr i } {
	set y [ transY $by2($i) 2 ]
	set s2 "$s2:$xdist2:$y"
	set s20 "$s20 $y"
	#set s20 "$s20 $by2(1)"
    }
    switch $mode {
	0 { puts "$mksndbin $sec $freq $s1 $s2 $sndraw > /dev/audio" }
	1 {
	    if { $playmode == 1 } then { # Solaris /dev/audio
		exec $mksndbin $sec $freq $s1 $s2 $sndraw | cat > /dev/audio
	    } elseif { $playmode == 2 } then { # FreeBSD /dev/audio
		exec $mksndbin $sec $freq $s1 $s2 $sndraw > /dev/audio
	    } else { 
		exec $mksndbin $sec $freq $s1 $s2 $sndform > $tmpsnd
		exec $auplay $tmpsnd
	    } 
	}
	2 { exec $mksndbin $sec $freq $s1 $s2 $sndform > $tmpsnd }
	5 { exec $mksndbin $sec $freq $s1 $s2 0 > $tmpf }
	6 { 
	    exec echo "$sec" > $dataf
	    exec echo "$freq" >> $dataf
	    exec echo "$s10" >> $dataf
	    exec echo "$s20" >> $dataf
	}
    }
}

set openedgp 0 
set fid 0

### mode = 0: global
### mode = 1: local
proc graphview { mode } { 
    global openedgp fid sec freq N1
    global gnuplot tmpf gpp
    
    set xmin 0.0
    if { $mode == 0 } then {
	set xmax $sec
	set plotop "every $N1 using 1:2 w l 3"
	if { $gpp } then {
	    set title "ǡȷ (Τȷ)"
	} else {
	    set title "Sound data wave curve (global)"
	}
	set yrange "\[-1:1\]"
    } else {
	set xmax [ expr 4.0/$freq ]
	set plotop "using 1:2 w lp 1"
	if { $gpp } then {
	    set title "ǡȷ (ȷ)"
	} else {
	    set title "Sound data wave curve (local)"
	}
	set yrange "\[*:*\]"
    }
    putall 5
    if { $openedgp == 0 } then {
	# set fid [ open "| gnuplot" "w" ]
	# set fid [ open "| gnuplot-3.8k.3+" "w" ]
	set fid [ open "| $gnuplot" "w" ]
	puts $fid "set nokey"
	if { $gpp } then {
	    puts $fid "set xlabel ''"
	    puts $fid "set ylabel ''"
	} else {
	    puts $fid "set xlabel 'second'"
	    puts $fid "set ylabel 'power range'"
	}
	set openedgp 1
    }
    puts $fid "set title '$title'"
    puts $fid "set xrange \[$xmin:$xmax\]"
    puts $fid "set yrange $yrange"
    puts $fid "plot '$tmpf' $plotop"
    flush $fid
}


# screen  y  -> y? 
proc transY { y n } {
    global Y1 Y2 MaxY1 MinY1 MaxY2 MinY2

    if { $n == 1 } then { 
	return [ expr ($MaxY1-$MinY1)*($y-$Y2)/($Y1-$Y2)+$MinY1 ] 
    } else { 
	return [ expr ($MaxY2-$MinY2)*($y-$Y2)/($Y1-$Y2)+$MinY2 ]
    }
}

# transY εѴ
proc revtransY { Y n } {
    global Y1 Y2 MaxY1 MinY1 MaxY2 MinY2

    if { $n == 1 } then { 
	return [ expr ($Y1-$Y2)*($Y-$MinY1)/($MaxY1-$MinY1)+$Y2 ]
    } else { 
	return [ expr ($Y1-$Y2)*($Y-$MinY2)/($MaxY2-$MinY2)+$Y2 ]
    }
}

##
## ɥ
##
wm title . test1
##
## menu
##
#. configure -menu .mainmenu
#menu .mainmenu
#.mainmenu add cascade -label File -menu .mainmenu.sub1
#menu .mainmenu.sub1 -tearoff no
#.mainmenu.sub1 add command -label quit -command exit
## .mainmenu.sub1 add command -label putall -command putall
#.mainmenu add command -label testput -command putall
#### main menu ľܥޥɥܥɲäǤʤ ?
#
###
### menu Ϥ button ˤ
###
frame .topbuttons
button .topbuttons.quit -text quit -command exit
button .topbuttons.testput -text "test putout" -command testputall
button .topbuttons.applytest -text "apply (test)" -command { putall 0 }
button .topbuttons.apply -text "sound" -command { putall 1 }
button .topbuttons.fsndout -text "file output (sound file)" -command { putall 2 }
button .topbuttons.ftxtout -text "file output (text data)" -command { putall 6 }
button .topbuttons.graph1 -text "graph (global)" -command { graphview 0 }
button .topbuttons.graph2 -text "graph (local)" -command { graphview 1 }
#button .topbuttons.apply -text apply -command bell
#button .topbuttons.dummy -text dummy -command bell
pack .topbuttons -side top -fill x -expand no
### ΤȡΤ·
#pack .topbuttons.quit .topbuttons.testput .topbuttons.applytest \
#    .topbuttons.apply .topbuttons.fsndout .topbuttons.ftxtout \
#    .topbuttons.graph1 .topbuttons.graph2 -side left
pack .topbuttons.quit .topbuttons.apply \
   .topbuttons.graph2 .topbuttons.graph1 \
   .topbuttons.fsndout .topbuttons.ftxtout \
   -side left


##
## canvas
##
set marginY 50
set marginX 50
set bw 15
set bh 15
set xdist 30
set lw 2
set Y1 $marginY
set Y2 [expr $marginY + 200 ]

set N1 10
set MaxY1 100
set MinY1 -100

set N2 10
set MaxY2 100
set MinY2 0
###
### MaxY? <-> Y1, MinY? <-> Y2 Ѵ򤹤롣
###
set sec 0

if { $argc > 0 } then {
    set N1 [ lindex $argv 0 ]
    if { $N1 < 1 } then {
	puts "Usage: wish mksnd1.tcl (N1) (N2) (file)"
	puts "($argv)"
	exit
    }
    if { $argc > 1 } then {
	set N2 [ lindex $argv 1 ]
	if { $N2 < 1 } then {
	    puts "Usage: wish mksnd1.tcl (N1) (N2) (file)"
	    puts "($argv)"
	    exit
	}
    }
    if { $argc > 2 } then {
	set dataf [ lindex $argv 2 ]
	if { [ file exists $dataf ] > 0 } then {
	    set datafid [ open $dataf r ]
	    if { [ gets $datafid sec ] <=0 } then {
		puts "File [$dataf] have some errors."
		exit
	    }
	    if { [ gets $datafid freq ] <=0 } then {
		puts "File [$dataf] have some errors."
		exit
	    }
	    if { [ gets $datafid s0 ] <=0 } then {
		puts "File [$dataf] have some errors."
		exit
	    }
	    for { set i 1 } { $i <= [ llength $s0 ] } { incr i } {
		set by1($i) [ revtransY [ lindex $s0 [ expr $i - 1 ] ] 1 ]
	    }
	    if { [ gets $datafid s0 ] <=0 } then {
		puts "File [$dataf] have some errors."
		exit
	    }
	    for { set i 1 } { $i <= [ llength $s0 ] } { incr i } {
		set by2($i) [ revtransY [ lindex $s0 [ expr $i - 1 ] ] 2 ]
	    }
	    close $datafid
	}
    }
}

set WIDTH [ expr $marginX+$xdist*($N1-1)+$marginX+$xdist*($N2-1)+$marginX ]
set HEIGHT [ expr $Y2 + $marginY ]

canvas .can -background white -width $WIDTH -height $HEIGHT

###
###  (sec, freq, by1, by2)
###
if { $sec == 0 } then {
    set sec 1.5
    set freq 200
    #set y1 [ expr ($Y1+$Y2)/2 ]
    set y1 $Y1
    set y2 $Y2
    for { set i 1 } { $i <= $N1 } { incr i } { 
	#    set by1($i) $y1
	set by1($i) [ expr ($i%2 == 1)? $y1 : $y2 ]
    }
    #set y1 $Y2
    set y1 [ expr $Y1 + ($Y2-$Y1)/5 ]
    for { set i 1 } { $i <= $N2 } { incr i } { 
	set by2($i) $y1
    }
}

##
## slider
##
frame .sliders
frame .sliders.sec
frame .sliders.freq
pack .sliders.sec .sliders.freq -side left -fill x

set Minsec 1
set Maxsec 5
set Minfreq 100
set Maxfreq 800

scale .sliders.sec.secslider -showvalue yes -from $Minsec -to $Maxsec \
  -resolution 0.1 -tickinterval [ expr $Maxsec - $Minsec ] \
  -length [expr $WIDTH/3] -orient horizontal -variable sec -label length
scale .sliders.freq.freqslider -showvalue yes -from $Minfreq -to $Maxfreq \
  -resolution 1 -tickinterval [ expr $Maxfreq - $Minfreq ] \
   -length [expr $WIDTH/3] -orient horizontal -variable freq -label frequency

pack .sliders.sec.secslider -side left -fill x
pack .sliders.freq.freqslider -side right -fill x

pack .topbuttons .can .sliders -side top


###
### bind
### 1) ޤƤȢ˰㤦 bind 򤹤ΤǤϤʤƱ bind 򤷤ơ
###    Ȥ⤢뤫⡣
### 2) Ѳ

for { set i 1 } { $i <= $N1 } { incr i } { 
    .can bind box1-$i <B1-Motion> "box1setup .can $i %x %y"
    .can bind box1-$i <Enter> "box1color .can $i gray"
    .can bind box1-$i <Leave> "box1color .can $i red"
}
for { set i 1 } { $i <= $N2 } { incr i } { 
    .can bind box2-$i <B1-Motion> "box2setup .can $i %x %y"
    .can bind box2-$i <Enter> "box2color .can $i gray"
    .can bind box2-$i <Leave> "box2color .can $i blue"
}


###
###  Ȣ (bx1,bx2 ν⤳)
###
for { set i 1 } { $i <= $N1 } { incr i } { 
    set bx1($i) [ expr $marginX+$xdist*($i-1) ]
    drawbox .can $bx1($i) $by1($i) red box1-$i
#    drawbox .can $bx1($i) $by1($i) red [ list box1-$i box1 ]
    if { $i > 1 } then {
	.can create line $bx1([expr $i-1]) $by1([expr $i-1]) $bx1($i) $by1($i) \
		-tags line1-[expr $i-1] -width $lw
    }
}

set xN1 [ expr $marginX+$xdist*($N1-1)+$marginX ]
for { set i 1 } { $i <= $N2 } { incr i } { 
    set bx2($i) [ expr $xN1+$xdist*($i-1) ]
    drawbox .can $bx2($i) $by2($i) blue box2-$i
#    drawbox .can $bx2($i) $by2($i) blue [ list box2-$i box2 ]
    if { $i > 1 } then {
	.can create line $bx2([expr $i-1]) $by2([expr $i-1]) $bx2($i) $by2($i) \
		-tags line2-[expr $i-1] -width $lw
    }
}
.can create line $bx1(1) $Y1 $bx1($N1) $Y1
.can create line $bx1(1) $Y2 $bx1($N1) $Y2
.can create line $bx1(1) [ expr ($Y1+$Y2)/2 ] $bx1($N1) [ expr ($Y1+$Y2)/2 ]

.can create line $bx2(1) $Y1 $bx2($N2) $Y1
.can create line $bx2(1) $Y2 $bx2($N2) $Y2
