/* ǡ monoral data Ф
 * 12/30 2003
 * shige
 * sndchan.c
 *
 * $Id: sndchan.c,v 1.4 2005-08-28 17:58:59+09 shige Exp $
 */
/* sndchan (-o [file]) -c[n] [file0]
 *  -c[n]: 
 *  -c1: left data  stdout (or [file])
 *  -c2: right data  stdout (or [file])
 *
 * 1)	n=0 ʤ顢줾 file ̾ file 뤳ȤˤƤ⤤
 * 2)	sox Ǥ
 * 	     sox file.wav -c 1 hoge.wav pick -l (-r)
 *	ǤǤ롣
 * 3)	psselect ˻ channel γĥԤʤ
 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include "common.h"

#define Maxchan 50
#define OpSep ","

int main(int argc,char *argv[]);
int chminus(char *s,int *N1,int *N2);
int str2charray(char *s,int lastch,int charray[]);
int getarg(int argc,char **argv,char **Chstr,FILE **infile,FILE **outfile);
void usage(int ret);

int main(int argc,char *argv[])
{
    FILE *infile,*outfile;
    SNDheader snd;
    int charray[Maxchan],chn,ch0,format,blocks,bs,bps;
    int j,k,ret;
    char *chs;
    double chdata[Maxchan];
    
    if((ret=getarg(argc,argv,&chs,&infile,&outfile))<=0){
	usage(ret); return -ret;
    }
    if((format=getSNDheader(infile,&snd))<0 || format==E_UNKNOWN){
	fprintf(stderr,"Error: In getSNDheader(). (%d)\n",ret);
	return 20;
    }
    if((ch0=SNDchannels(&snd,format))>Maxchan){
	fprintf(stderr,"Error: too many channels in data. (%d)\n",ch0);
	return 30;
    }
    if((chn=str2charray(chs,ch0,charray))<0){
	fprintf(stderr,"Error: str2charray(). (%d)\n",chn);
	return 40;
    }
    blocks=SNDblocks(&snd,format);
    bps=SNDbitpersmpl(&snd,format);
#ifdef DEBUG1
    fprintf(stderr,"(blocks,bps,ch0,chn)=(%d,%d,%d,%d)\n",blocks,bps,ch0,chn);
#endif
    putSNDheaderBlocksChannels(outfile,&snd,blocks,chn,format);
    for(j=1;j<=blocks;j++){
	for(k=1;k<=ch0;k++) 
	  chdata[k-1]=SNDget1chleveldata(infile,&snd,format);
	for(k=1;k<=chn;k++)
	  SNDput1chleveldata(outfile,chdata[charray[k-1]-1],&snd,format);
    }
    bs=SNDblocksize(&snd,format)/chn;
    if(format!=E_AU && bs%2 && blocks%2) fputc(0,outfile);
    return 0;
}

/* return valu: A ==> 0, -A ==> 1, A- ==> 2, A-B ==> 3
 */
int chminus(char *s,int *N1,int *N2)
{
    int len,n,m,num;

    num=0;
    if((len=strlen(s))<=0) return -1;
    for(n=0;n<len;n++)
      if(s[n]=='-'){ m=n; num++; }
      else if(!isdigit(s[n])) return -2;
    if(num>1) return -3;
    if(num==0){
	if(s[n]=='0') return -4;
	*N1=atoi(s); *N2=0; 
	return 0;
    }
    else if(m==0){
	if(*(++s)=='\0') return -5;
	*N1=0; *N2=atoi(s);
	return 1;
    }
    else if(m==len-1){
	if(s[0]=='0') return -6;
	s[len-1]='\0';
	*N1=atoi(s); *N2=0;
	s[len-1]='\0';
	return 2;
    }
    else{
	if(s[0]=='0' || s[m+1]=='0') return -7;
	s[m]='\0';
	*N1=atoi(s); *N2=atoi(s+m+1);
	s[m]='-';
	if(*N1>*N2) return -8;
	else return 3;
    }
}

int str2charray(char *s,int lastch,int charray[])
{
    char *sp[Maxchan];
    int j,k,N,n1,n2,ret,index=0;

    if(lastch<=0) return -1;
    sp[0]=strtok(s,OpSep);
    for(j=2;j<=Maxchan;j++) if((sp[j-1]=strtok(NULL,OpSep))==NULL) break;
    if(j>Maxchan) return -2;

    N=j-1;
    for(j=1;j<=N;j++){
	if((ret=chminus(sp[j-1],&n1,&n2))<0) return ret-10;
	switch(ret){
	case 0:
	    if(n1>lastch) break;
	    if(index+1>Maxchan) return -3;
	    charray[++index-1]=n1;
	    break;
	case 1:
	    if(n2>lastch) n2=lastch;
	    if(index+n2>Maxchan) return -4;
	    for(k=1;k<=n2;k++) charray[++index-1]=k;
	    break;
	case 2:
	    if(n1>lastch) break;
	    if(index+lastch-n1+1>Maxchan) return -5;
	    for(k=n1;k<=lastch;k++) charray[++index-1]=k;
	    break;
	case 3:
	    if(n1>lastch) break;
	    if(n2>lastch) n2=lastch;
	    if(index+n2-n1+1>Maxchan) return -6;
	    for(k=n1;k<=n2;k++) charray[++index-1]=k;
	    break;
	default:
	    return -7;
	}
    }
    return index;
}

int getarg(int argc,char **argv,char **Chstr,FILE **infile,FILE **outfile)
{
    *outfile=stdout;
    *infile=stdin;
    *Chstr=NULL;

    while(--argc>0){
	if(**(++argv)=='-'){
	    switch(*(++*argv)){
	    case 'c': 
		if(*(++*argv)=='\0'){ 
		    if(--argc<=0) return -1;
		    else argv++;
		}
		*Chstr=*argv;
		break;
	    case 'h':
	    case 'H':
	    case '?': return 0;
	    case 'o':
		if(*outfile!=stdout) return -3;
		if(*(++*argv)=='\0'){ 
		    if(--argc<=0) return -4;
		    else argv++;
		}
		if(!strcmp(*argv,"-")) *outfile=stdout;
		else if((*outfile=fopen(*argv,"w"))==NULL){
		    fprintf(stderr,"File [%s] open error.\n",*argv);
		    return -5;
		}
		break;
	    case '\0': break;
	    default: return -6;
	    }
	    if(**argv=='\0'){ --*argv; break; }
	}
	else break;
    }
    if(argc>1){
#ifdef DEBUG1
	fprintf(stderr,"DEBUG1: %d\n",argc);
#endif
	return -7;
    }
    if(argc<1) return 1;
    if(!strcmp(*argv,"-")) *infile=stdin;
    else if((*infile=fopen(*argv,"r"))==NULL){
	fprintf(stderr,"File [%s] open error.\n",*argv);
	return -9;
    }
    return 1;
}

void usage(int ret)
{
    char *mess[]={
	"Usage: sndchan (-o [outfile]) -c[s] ([infile])",
	"   -o [outfile] : ϥեλ (default: ɸ)",
	"   -c[s]: Фͥ (ɬ)",
	"   [infile]: ϥե (ά: ɸ)",
	" ",
	" [1] ϥե '-' ꤷɸϤˤʤ롣",
	" [2] ͥϡpsselect Ʊ ',' '-' ϰϤ̣",
	"   롣:",
	"     -c2,4: 2 ͥ, 4 ͥ",
	"     -c2-4: 2 ͥ뤫 4 ͥޤ",
	"     -c2- : 2 ͥ뤫ǽͥޤ",
	"     -c-3 : 1 ͥ뤫 3 ͥޤ",
	NULL
    };
    int j;

#ifdef DEBUG1
    printf("USAGE: %d\n",ret);
#endif
    for(j=0;mess[j]!=NULL;j++)
      fprintf(stderr,"%s\n",mess[j]);
}
